/**
 * gclc-swt:fr.bigeon.gclc.swt.SWTConsoleShellTest.java
 * Created on: Jun 8, 2016
 */
package fr.bigeon.gclc.swt;

import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;

import org.eclipse.swt.widgets.Display;
import org.junit.Test;

import fr.bigeon.gclc.ConsoleApplication;
import fr.bigeon.gclc.command.Command;
import fr.bigeon.gclc.exception.InvalidCommandName;
import fr.bigeon.gclc.manager.ConsoleManager;

/**
 * <p>
 * TODO
 *
 * @author Emmanuel Bigeon
 *
 */
public class SWTConsoleShellTest {

    protected static final long TWO_SECONDS = 2000;

    @Test
    public void test() {
        Display display = new Display();
        final SWTConsoleShell shell = new SWTConsoleShell(display);
        ConsoleManager swtConsole = shell.getManager();
        try {
            final ConsoleApplication appl = new ConsoleApplication(swtConsole,
                    "exit", "Hello", "See you");
            appl.add(new Command("long") {

                @Override
                public String tip() {
                    return "a long running command";
                }

                @Override
                public void execute(String... args) {
                    try {
                        Thread.sleep(TWO_SECONDS);
                    } catch (InterruptedException e) {
                        // TODO Auto-generated catch block
                        e.printStackTrace();
                    }
                }
            });
//            shell.pack();
            shell.open();
            Thread applThread = new Thread(new Runnable() {

                @Override
                public void run() {
                    appl.start();
                }
            });
            Thread testThread = new Thread(new Runnable() {

                @Override
                public void run() {
                    try {
                        Thread.sleep(TWO_SECONDS);
                    } catch (InterruptedException e) {
                        // TODO Auto-generated catch block
                        e.printStackTrace();
                    }
                    Display.getDefault().syncExec(new Runnable() {
                        @Override
                        public void run() {
                            shell.dispose();
                        }
                    });
                }
            });
            applThread.start();
            testThread.start();
            while (!shell.isDisposed()) {
                if (!display.readAndDispatch()) {
                    display.sleep();
                }
            }
//            display.dispose();
            assertTrue(appl.getManager().isClosed());
            Thread.sleep(TWO_SECONDS);
            assertFalse(appl.isRunning());
        } catch (InvalidCommandName e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (InterruptedException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }
}
